From 6e2d26bb88aea654c6e5975e7344351e66ca00d3 Mon Sep 17 00:00:00 2001
From: Pierre-Yves Chibon <pingou@pingoured.fr>
Date: Apr 26 2016 13:47:08 +0000
Subject: [PATCH 453/1001] Enforce that each widget has a position that must be in 'left', 'right' or 'both'


---

diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index 551876a..2e72e00 100755
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -57,6 +57,13 @@ def validate_registry(registry):
         if not callable(module.template.render):
             raise TypeError('%r\'s template.render not callable' % module)
 
+        if not hasattr(module, 'position'):
+            raise AttributeError('%r has not "position" function' % module)
+        if module.position not in ['left', 'right', 'both']:
+            raise TypeError(
+                '%r\'s "position" is not: `left`, `right` or `both`'
+                % module)
+
         if not hasattr(module, 'data'):
             raise AttributeError('%r has not "data" function' % module)
         if not callable(module.data):

